<template>
    <div id="app" style="max-width: 1000px; margin: auto">
        <h1>The awesome METRO ToDo app</h1>
        <h2>Using the "Element" framework</h2>

        <!-- The form -->
        <el-form :inline="true" :rules="rules" :model="form" ref="form" class="demo-form-inline">
                    <el-form-item prop="todo">
                        <!-- How do we specify the width of a form field? -->
                        <el-input v-model="form.todo" placeholder="Type your todo here"
                                  style="width: 300px"
                        ></el-input>
                    </el-form-item>
                    <el-form-item>
                        <el-select v-model="form.priority" placeholder="Priority">
                            <el-option
                                    v-for="item in this.priorities"
                                    :key="item"
                                    :label="item"
                                    :value="item">
                            </el-option>
                        </el-select>
                    </el-form-item>
                    <el-form-item>
                        <el-date-picker
                                v-model="form.deadline"
                                type="date"
                                placeholder="Deadline">
                        </el-date-picker>
                    </el-form-item>
                    <el-form-item>
                        <el-button type="primary" @click="onSubmit">Submit</el-button>
                    </el-form-item>
        </el-form>

        <!-- The table -->
        <el-table
                :data="items"
                style="width: 100%">
            <el-table-column
                    fixed
                    prop="description"
                    label="Description"
                    sortable
            >
            </el-table-column>
            <el-table-column
                    prop="deadline"
                    label="Deadline"
                    sortable
                    :formatter="formatter">
            </el-table-column>
            <el-table-column
                    prop="priority"
                    label="Priority">
            </el-table-column>

            <el-table-column
                    fixed="right"
                    width="50px"
            >
                <template slot-scope="scope">
                    <el-button @click="onDelete(scope.$index, scope.row)" type="text"><i
                            class="el-icon-delete"></i></el-button>
                </template>
            </el-table-column>
        </el-table>
        <el-pagination style="text-align: center"
                       layout="prev, pager, next"
                       :total="2">
        </el-pagination>
    </div>
</template>

<script>
    import moment from 'moment'

    export default {
        name: 'app',
        data() {
            return {
                form: {
                    todo: ''
                },

                // Validation rules
                rules: {
                    todo: [
                        {required: true, message: 'Please input Activity name', trigger: 'blur'},
                        {min: 3, message: 'Length should be 3 at least 34', trigger: 'blur'}
                    ],
                },

                // Values for the dropdown
                priorities: [
                    'low',
                    'medium',
                    'high',
                    'blocker'
                ],

                // Initial items
                items: [
                    {
                        description: "Buy some potatoes",
                        deadline: new Date(2018, 9, 1),
                        priority: 'high'
                    },
                    {
                        description: "Cook Dranikis",
                        deadline: new Date(2018, 9, 2),
                        priority: 'medium'
                    },
                    {
                        description: "Clean up the kitchen",
                        deadline: new Date(2018, 9, 3),
                        priority: 'low'
                    }
                ]
            }
        },
        mounted() {
            moment.locale('de');
        },
        methods: {
            onSubmit() {
                this.$refs['form'].validate((valid) => {
                    if (valid) {
                        this.items.push({
                            description: this.form.todo,
                            deadline: this.form.deadline,
                            priority: this.form.priority,
                            added: new Date()
                        })
                        this.$notify({
                            message: 'The item has been added',
                            duration: 2000
                        });
                        this.form.todo = ''
                        this.form.deadline = ''
                        this.form.priority = ''
                    }
                })
            },
            onDelete(index) {
                this.$confirm('Are you sure to delete this item?')
                    .then(() => {
                        this.items.splice(index, 1);
                        this.$notify({
                            message: 'The item has been deleted',
                            duration: 2000
                        });
                    })
                    .catch(() => {
                    });

            },
            formatter(row) {
                return moment(row.deadline).format('L');
            }
        }
    }
</script>

<style>
    body {
        font-family: "Helvetica Neue", Helvetica, "PingFang SC", "Hiragino Sans GB", "Microsoft YaHei", "微软雅黑", Arial, sans-serif;
    }
</style>
